package com.example.nto.controller;

import com.example.nto.entity.Code;
import com.example.nto.entity.Employee;
import com.example.nto.entity.EmployeeWithCode;
import com.example.nto.service.EmployeeService;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.swagger.v3.core.util.Json;
import javassist.tools.web.BadHttpRequest;
import lombok.AllArgsConstructor;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;

import java.lang.reflect.Array;
import java.util.List;

@RestController
@RequestMapping("/api")
@AllArgsConstructor
public class EmployeeController {
    private final EmployeeService employeeService;

    @GetMapping("/auth")
    @ResponseStatus(HttpStatus.OK)
    public void auth(@RequestBody Employee employee) {
        employeeService.checkEmployee(employee);
    }

    @GetMapping("/info")
    @ResponseStatus(HttpStatus.OK)
    public Employee info(@RequestBody Employee employee) {
        return employeeService.getEmployee(employee);
    }

    @PatchMapping("/open")
    @ResponseStatus(HttpStatus.OK)
    public void open(@RequestBody EmployeeWithCode Data) {
        Employee employee = Data.getEmployee();
        Code code = (Code) Data.getCode();
        employeeService.open(employee, code);
    }
}
