package com.example.nto.service.impl;

import com.example.nto.entity.Code;
import com.example.nto.entity.Employee;
import com.example.nto.exception.IncorrectBodyException;
import com.example.nto.exception.NoSuchEmployeeException;
import com.example.nto.repository.CodeRepository;
import com.example.nto.repository.EmployeeRepository;
import com.example.nto.service.EmployeeService;
import javassist.tools.web.BadHttpRequest;
import lombok.AllArgsConstructor;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ResponseStatus;

import java.util.List;

@Service
@AllArgsConstructor
public class EmployeeServiceImpl implements EmployeeService {
    private final CodeRepository codeRepository;
    private final EmployeeRepository employeeRepository;
    private final BCryptPasswordEncoder bCryptPasswordEncoder;

    @Override
    public Employee getEmployee(Employee employee_r) throws NoSuchEmployeeException {
        List<Employee> employee = employeeRepository.findByLogin(employee_r.getLogin());
        if (employee.isEmpty()) {
            throw new NoSuchEmployeeException("Неверный логин или пароль");
        } else {
            return employee.get(0);
        }
    }

    @Override
    public void checkEmployee(Employee employee_r) throws NoSuchEmployeeException{
        Employee employee = getEmployee(employee_r);
        if(!(bCryptPasswordEncoder.matches(employee_r.getPassword(), employee.getPassword()))) {
            throw new NoSuchEmployeeException("Неверный логин или пароль");
        }
    }

    @Override
    public void open(Employee employee_r, Code code) {
        getEmployee(employee_r);
        List<Code> codeList = codeRepository.findByCode(code.getValue());

        if (codeList.isEmpty()) {
            throw new IncorrectBodyException("incorrect body");
        }


    }
}
