package com.example.nto.service.impl;

import com.example.nto.entity.Employee;
import com.example.nto.exception.NoSuchEmployeeException;
import com.example.nto.repository.EmployeeRepository;
import lombok.RequiredArgsConstructor;
import org.springframework.security.core.authority.SimpleGrantedAuthority;
import org.springframework.security.core.userdetails.User;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
@RequiredArgsConstructor
public class H2UserDetailsService implements UserDetailsService {
    private final EmployeeRepository employeeRepository;

    @Override
    public UserDetails loadUserByUsername(String username) throws NoSuchEmployeeException {
        List<Employee> employees = employeeRepository.findByLogin(username);

        if(employees == null) {
            throw new NoSuchEmployeeException("User not found");
        }
        Employee employee = employees.get(0);
        List<SimpleGrantedAuthority> authorities = List.of(new SimpleGrantedAuthority(employee.getRole()));

        return new User(employee.getLogin(), employee.getPassword(), authorities);
    }
}